"Use strict";
import powerbi from "powerbi-visuals-api";
import IVisualHost = powerbi.extensibility.visual.IVisualHost;
import DataView = powerbi.DataView;
import * as visualInterfaces from "../visual/visualInterfaces";
import * as d3 from "d3";
import { IFilterManager } from "../visual/visualInterfaces";
import * as models from 'powerbi-models';
import { select, json } from "d3";

export class FilterManager implements IFilterManager{
    private target: models.IFilterColumnTarget={table:'',column:''};
    private host:IVisualHost;
    constructor(host:IVisualHost){
        this.host=host;
    }
    public update(field:powerbi.DataViewCategoryColumn):void{
        let queryName:string=field.source.queryName;
        let splitPosition:number=queryName.indexOf('.');
        this.target.table=queryName.substring(0,splitPosition); // table
        this.target.column=queryName.substring(splitPosition+1,queryName.length); // column
        console.debug("queryName:",queryName);
        console.debug("queryName.length:",queryName.length);
        console.debug("filterManager update end, now filter:",this.target);
    }
    public filterStringField(selection:string[]):void{
        console.debug("filterStringField start");
        let jsonFilter:models.IBasicFilter={
            "$schema": "http://powerbi.com/product/schema#basic",
            "target": this.target,
            "filterType": models.FilterType.Basic,
            "operator":"In",
            "values": selection
        }
        console.debug("jsonFilter:",jsonFilter);
        this.host.applyJsonFilter(jsonFilter?jsonFilter:null,"general","filter",powerbi.FilterAction.merge);
        console.debug("filterStringField end");
    }
}